#pragma warning( disable : 4244 )

#include <string>
#include <iostream>

#include "viewer.h"
#include "scene.h"
#include "mesh.h"

int main(int argc, char **argv)
{
	// there should be one obj file given as command argument
	if (argc == 2)
	{
		CScene* pScene = CScene::getScene();
		std::string meshFilename = argv[1];

		CMesh* pMesh1 = pScene->addMesh(meshFilename);
		CMesh* pMesh2 = pScene->addMesh(meshFilename);

		// if the following trasnformations are applied, the optimization exercise on exercise sheet four has to be implemented.
		// otherwise, the algorithm will not work!
		pMesh1->addTranslation(gmVector3(0.0, 1.0, 0.0));
		pMesh1->setSpecularMaterial(1.0, 0.0, 0.0);
		pMesh2->addTranslation(gmVector3(0.2, -1.0, 0.0));
		pMesh2->setSpecularMaterial(0.0, 0.0, 1.0);
	}
	else
	{
    CScene* pScene = CScene::getScene();
    CMesh* pMesh1 = pScene->addMesh(std::string("cube.obj"));
    CMesh* pMesh2 = pScene->addMesh(std::string("cube.obj"));

		// if the following trasnformations are applied, the optimization exercise on exercise sheet four has to be implemented.
		// otherwise, the algorithm will not work!
		pMesh1->addTranslation(gmVector3(0.0, 1.0, 0.0));
		pMesh1->setSpecularMaterial(1.0, 0.0, 0.0);
		pMesh2->addTranslation(gmVector3(0.2, -1.0, 0.0));
		pMesh2->setSpecularMaterial(0.0, 0.0, 1.0);

    std::cout << "Usage: viewer <.obj file name>" << std::endl
      << "Loading standard object." << std::endl;
	}

	// get the single viewer, init and loop
	CViewer* pViewer = CViewer::getViewer();  
	pViewer->initialize(argc, argv);
	pViewer->loop();

	return 0;
}