/******************************************************************************
 * depth shader code
 * provides vertex and fragment shader in the form of a character string
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/
#pragma once

#include "globals.h"

const GLchar *shader_depth_vert =
"varying vec4 v_position;\n"
"\n"
"void main(void)\n"
"{\n"
"	gl_Position = ftransform();\n"
"	v_position = gl_Position; \n"
"}\n";

const GLchar *shader_depth_frag =
"varying vec4 v_position;\n"
"\n"
"void main (void)\n"
"{\n"
"	float depth = v_position.z / v_position.w;\n"
"	depth = depth * 0.5 + 0.5;\n"
"	\n"
"	float moment1 = depth;\n"
"	float moment2 = depth * depth;\n"
"	\n"
"	// bias per pixel using derivative\n"
"	float dx = dFdx(depth);\n"
"	float dy = dFdy(depth);\n"
"	\n"
"	moment2 += 0.25 * (dx*dx + dy*dy);\n"
"	\n"
"	gl_FragColor = vec4(moment1, moment2, 0.0, 0.0);\n"
"}\n";
