/******************************************************************************
 * shadowmap.h 
 * implements the construction and drawing of shadow maps
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/

#ifndef SHADOWMAPS_H
#define SHADOWMAPS_H

#include "shadow.h"
#include "gmMath\gmVec3.h"

// ------------------------------------------------------------
// forward declarations
// 

class CShaderProgramDepth;
class CShaderProgramShadowMap;

// ------------------------------------------------------------
// defines thes shadowmap class
// 

class CShadowMap : public CShadow
{
	bool m_checkValidity();

	void m_drawWithShadowMap();
	
public:
	// constructor/destructor
	CShadowMap();
	~CShadowMap();

	// builds the shadow map for this light
	void build(int lightId, gmVector3& lightPos);

	virtual void clear();

	// draws the scene with shadows
	virtual void drawSceneWithShadows();

	// member variables
private:
	CShaderProgramDepth* m_shaderDepth;
	CShaderProgramShadowMap* m_shaderShadowMap;
	
	GLuint m_shadowFrameBufferHandle;
	GLuint m_shadowMap;
	GLuint m_shadowMapDepth;	
	GLuint m_shadowMapColor;
	
	GLuint m_shadowMapDebug;

	int m_shadowMapSize[2];
};

#endif
